// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package comment

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// CmtSrvClient is the client API for CmtSrv service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type CmtSrvClient interface {
	AddComment(ctx context.Context, in *AddRequest, opts ...grpc.CallOption) (*AddReply, error)
	GetComments(ctx context.Context, in *CommentRequest, opts ...grpc.CallOption) (CmtSrv_GetCommentsClient, error)
	GetReplyOfComment(ctx context.Context, in *CommentRequest, opts ...grpc.CallOption) (CmtSrv_GetReplyOfCommentClient, error)
}

type cmtSrvClient struct {
	cc grpc.ClientConnInterface
}

func NewCmtSrvClient(cc grpc.ClientConnInterface) CmtSrvClient {
	return &cmtSrvClient{cc}
}

func (c *cmtSrvClient) AddComment(ctx context.Context, in *AddRequest, opts ...grpc.CallOption) (*AddReply, error) {
	out := new(AddReply)
	err := c.cc.Invoke(ctx, "/CmtSrv/AddComment", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *cmtSrvClient) GetComments(ctx context.Context, in *CommentRequest, opts ...grpc.CallOption) (CmtSrv_GetCommentsClient, error) {
	stream, err := c.cc.NewStream(ctx, &CmtSrv_ServiceDesc.Streams[0], "/CmtSrv/GetComments", opts...)
	if err != nil {
		return nil, err
	}
	x := &cmtSrvGetCommentsClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type CmtSrv_GetCommentsClient interface {
	Recv() (*Comment, error)
	grpc.ClientStream
}

type cmtSrvGetCommentsClient struct {
	grpc.ClientStream
}

func (x *cmtSrvGetCommentsClient) Recv() (*Comment, error) {
	m := new(Comment)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *cmtSrvClient) GetReplyOfComment(ctx context.Context, in *CommentRequest, opts ...grpc.CallOption) (CmtSrv_GetReplyOfCommentClient, error) {
	stream, err := c.cc.NewStream(ctx, &CmtSrv_ServiceDesc.Streams[1], "/CmtSrv/GetReplyOfComment", opts...)
	if err != nil {
		return nil, err
	}
	x := &cmtSrvGetReplyOfCommentClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type CmtSrv_GetReplyOfCommentClient interface {
	Recv() (*Comment, error)
	grpc.ClientStream
}

type cmtSrvGetReplyOfCommentClient struct {
	grpc.ClientStream
}

func (x *cmtSrvGetReplyOfCommentClient) Recv() (*Comment, error) {
	m := new(Comment)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// CmtSrvServer is the server API for CmtSrv service.
// All implementations must embed UnimplementedCmtSrvServer
// for forward compatibility
type CmtSrvServer interface {
	AddComment(context.Context, *AddRequest) (*AddReply, error)
	GetComments(*CommentRequest, CmtSrv_GetCommentsServer) error
	GetReplyOfComment(*CommentRequest, CmtSrv_GetReplyOfCommentServer) error
	mustEmbedUnimplementedCmtSrvServer()
}

// UnimplementedCmtSrvServer must be embedded to have forward compatible implementations.
type UnimplementedCmtSrvServer struct {
}

func (UnimplementedCmtSrvServer) AddComment(context.Context, *AddRequest) (*AddReply, error) {
	return nil, status.Errorf(codes.Unimplemented, "method AddComment not implemented")
}
func (UnimplementedCmtSrvServer) GetComments(*CommentRequest, CmtSrv_GetCommentsServer) error {
	return status.Errorf(codes.Unimplemented, "method GetComments not implemented")
}
func (UnimplementedCmtSrvServer) GetReplyOfComment(*CommentRequest, CmtSrv_GetReplyOfCommentServer) error {
	return status.Errorf(codes.Unimplemented, "method GetReplyOfComment not implemented")
}
func (UnimplementedCmtSrvServer) mustEmbedUnimplementedCmtSrvServer() {}

// UnsafeCmtSrvServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to CmtSrvServer will
// result in compilation errors.
type UnsafeCmtSrvServer interface {
	mustEmbedUnimplementedCmtSrvServer()
}

func RegisterCmtSrvServer(s grpc.ServiceRegistrar, srv CmtSrvServer) {
	s.RegisterService(&CmtSrv_ServiceDesc, srv)
}

func _CmtSrv_AddComment_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AddRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CmtSrvServer).AddComment(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/CmtSrv/AddComment",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CmtSrvServer).AddComment(ctx, req.(*AddRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _CmtSrv_GetComments_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(CommentRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(CmtSrvServer).GetComments(m, &cmtSrvGetCommentsServer{stream})
}

type CmtSrv_GetCommentsServer interface {
	Send(*Comment) error
	grpc.ServerStream
}

type cmtSrvGetCommentsServer struct {
	grpc.ServerStream
}

func (x *cmtSrvGetCommentsServer) Send(m *Comment) error {
	return x.ServerStream.SendMsg(m)
}

func _CmtSrv_GetReplyOfComment_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(CommentRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(CmtSrvServer).GetReplyOfComment(m, &cmtSrvGetReplyOfCommentServer{stream})
}

type CmtSrv_GetReplyOfCommentServer interface {
	Send(*Comment) error
	grpc.ServerStream
}

type cmtSrvGetReplyOfCommentServer struct {
	grpc.ServerStream
}

func (x *cmtSrvGetReplyOfCommentServer) Send(m *Comment) error {
	return x.ServerStream.SendMsg(m)
}

// CmtSrv_ServiceDesc is the grpc.ServiceDesc for CmtSrv service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var CmtSrv_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "CmtSrv",
	HandlerType: (*CmtSrvServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "AddComment",
			Handler:    _CmtSrv_AddComment_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "GetComments",
			Handler:       _CmtSrv_GetComments_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "GetReplyOfComment",
			Handler:       _CmtSrv_GetReplyOfComment_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "comment.proto",
}
